<?php

	class Monitino
	{
		public function getSensor($sensor, $filter)
		{
			$data = exec('sensors -u '.$sensor." | grep ".$filter);
			if (preg_match('/'.$filter.'([: ]+)([0-9]+)/', $data, $result))
			{
				return($result[2]);
			}
			return 0;
		}

		public function getDF($mountpoint)
		{
			$data = exec('df '.$mountpoint.' | grep '.$mountpoint);
			if (preg_match('/([0-9]+)%/', $data, $result))
			{
				return($result[1]);
			}
			return 0;
		}		
		
		public function getCoreInformation()
		{
			$data = file('/proc/stat');
			$cores = array();
			foreach ($data as $line)
			{
				if (preg_match('/^cpu([0-9])/', $line, $result))
				{
					$core = $result[1];
										
					$info = explode(' ', $line );
					$cores[$core] = array(
						'user' => $info[1],
						'nice' => $info[2],
						'sys' => $info[3],
						'idle' => $info[4]
					);
				}
			}
			
			return $cores;
		}

		public function getCpuPercentages($stat1, $stat2)
		{
			if (count($stat1) !== count($stat2))
			{
				return;
			}
			
			$cpus = array();
			
			foreach ($stat1 as $core => $data)
			{				
				$dif = array();
				$dif['user'] = $stat2[$core]['user'] - $stat1[$core]['user'];
				$dif['nice'] = $stat2[$core]['nice'] - $stat1[$core]['nice'];
				$dif['sys'] = $stat2[$core]['sys'] - $stat1[$core]['sys'];
				$dif['idle'] = $stat2[$core]['idle'] - $stat1[$core]['idle'];
								
				$total = array_sum($dif);
				
				$cpu = array();
				foreach($dif as $x=>$y) $cpu[$x] = round($y / $total * 100, 1);
				$cpus['cpu'.$core] = $cpu;
			}
			
			return $cpus;
		}

		public function getCPU()
		{
			$stat1 = $this->GetCoreInformation();
			usleep(1000000);
			$stat2 = $this->GetCoreInformation();
			$data = $this->GetCpuPercentages($stat1, $stat2);
			$cores = count($data);
			$idle = 0;
			
			foreach ($data as $core)
			{
				$idle += $core['idle'];
			}

			return 100 - round($idle/$cores,2);
						
		}
		
	}
?>